module PublicKeyPrompter

  def public_key_id(allow_none=false)
    return options[:public_key_id] if options[:public_key_id]
    return options[:public_key_id] = ENV['PUBLIC_KEY_ID'] if ENV['PUBLIC_KEY_ID']
    return options[:public_key_id] = prompt_for_public_key_id(allow_none)
  end

  private

  def prompt_for_public_key_id(allow_none)
    result = get("services/public_keys")

    (puts "No public keys have been created. Cannot continue"; exit 1) if result.empty?

    # Build a menu of the public keys
    puts
    return prompter.choose do | menu |
      menu.prompt = "Select the Public Key: "
      menu.choice("No Selection") { -1 } if allow_none
      result.each do | public_key |
        menu.choice(public_key['name']) { public_key['id'] }
      end
    end
  end

end
