module Resources

  class MdsPullAccount < BaseResource
    include ServicePrompter
    include ServiceDefinitionPrompter
    include ConfiguredAccountPrompter

    def list
      result = nil
      sv_id = service_id
      sd_id = service_definition_id(true)
      if sd_id > 0
        ca_id = configured_account_id(true)
        if ca_id > 0
          result = get("services/services/#{sv_id}/service_definitions/#{sd_id}/configured_accounts/#{ca_id}/mds_pull_accounts#{status_prompt}")
        else
          result = get("services/services/#{sv_id}/service_definitions/#{sd_id}/mds_pull_accounts#{status_prompt}")
        end
      else
        result = get("services/services/#{sv_id}/mds_pull_accounts#{status_prompt}")
      end
      puts "\nMds Pull Accounts"
      table = Terminal::Table.new headings: [ 'CA Id', 'Account', 'Status', 'Attempt', 'Created', 'Updated' ] do |t|
        result.each do | mds_pull_account |
          t << [ mds_pull_account['configured_account_id'],
                 "#{mds_pull_account['account_name']} (#{mds_pull_account['account_id']})",
                 mds_pull_account['status'],
                 mds_pull_account['attempt'],
                 mds_pull_account['created_at'],
                 mds_pull_account['updated_at'] ]
          
        end
      end
      prompter.say table.to_s
      puts
    end

    def status_prompt
      puts 
      status = prompter.choose do | menu |
        menu.prompt = "Select the status to filter the results with: "
        menu.choice("Do not filter by status") { -1 }
        menu.choice("New") { 0 }
        menu.choice("Providers Identified") { 1 }
        menu.choice("Assessments Requested") { 2 }
        menu.choice("Files Identified") { 3 }
        menu.choice("Files Downloaded") { 4 }
        menu.choice("Submitted to abaqis") { 5 }
        menu.choice("File System Clean") { 6 }
        menu.choice("Remote Clean") { 7 }
        menu.choice("Not Remote Clean") { 0x17 }
      end
      status < 0 ? "" : "?status=#{status}"
    end
    
  end

end
