module Resources

  class Provider < BaseResource
    include ThirdPartyPrompter
    include ServiceDefinitionPrompter
    include ConfiguredAccountPrompter

    def list
      tp_id = third_party_id
      sd_id = service_definition_id
      ca_id = configured_account_id

      result = get("services/sltc_providers?configured_account_id=#{ca_id}")

      puts "\nProviders for account:"
      table = Terminal::Table.new headings: [ 'id', 'Name', 'State', 'NPI', 'CCN', 'FacId' ] do |t|
        result.each do | provider |
          t << [ provider['id'], 
                 provider['name'],
                 provider['state'], 
                 provider['npi'],
                 provider['ccn'],
                 provider['fac_id'] ]
        end
      end

      prompter.say table.to_s
      puts
    end

  end

end
